package src.hw4;
import java.util.*;
import src.dataStructures.*;

public class MergeMainNoTree {
	public static SatelliteData[] generateData() {
		final int BOUND= 200;
		Random r1 = new Random();
		int size = r1.nextInt(BOUND) +1;
		SatelliteData[] randomData = new SatelliteData[size];
		System.out.println("size is " + size);
		
		for(int i=0; i < size; i++) {
			randomData[i] = new SatelliteData();
			randomData[i].longitude= r1.nextDouble()* 360.0;
			randomData[i].cloudCover= r1.nextDouble();
			randomData[i].temperature= r1.nextDouble() * 400;
		}
		Arrays.sort(randomData);
	    return randomData;	
	}

	public static void main(String[] args)  {
		final int MAX_DATASETS= 20;
		Random r1 = new Random();
		int dataSets = r1.nextInt(MAX_DATASETS) +1;
		System.out.println("Number of datasets: " + dataSets);

		Node[] tree= new Node[dataSets];
		for (int i= 0; i < tree.length; i++)
			tree[i]= new Node(generateData());
		
		// create the list of elements to be merged.
		MinHeap h = new MinHeap(tree);
		
		int weight= 0;
		for (int i =0; i< tree.length-1; i++) {		// -1 since we remove 2 TreeNodes from Heap each time
			Node lchild= (Node) h.delete();
			Node rchild= (Node) h.delete();
			Node pt = new Node(Merge.merge(lchild.data, rchild.data));
			weight += pt.data.length;
			h.insert(pt);
		}
		Node merged = (Node)h.delete();
	
		System.out.println("Merge is finished and the weight is " + weight);
		System.out.println("Number of data elements: "+ merged.data.length);
		for (int i= 0; i < merged.data.length; i++) {
			System.out.println("longitude is " + merged.data[i]);	
		}		
	}
}