package src.hw4;
import java.util.*;
import src.dataStructures.*;

public class MergeMainNoTreeAnalysis {
	public static SatelliteData[] generateData() {
		final int BOUND= 200;
		Random r1 = new Random();
		SatelliteData[] randomData = new SatelliteData[BOUND];

		for(int i=0; i < BOUND; i++) {
			randomData[i] = new SatelliteData();
			randomData[i].longitude= r1.nextDouble()* 360.0;
			randomData[i].cloudCover= r1.nextDouble();
			randomData[i].temperature= r1.nextDouble() * 400;
		}
		Arrays.sort(randomData);
		return randomData;	
	}

	public static void main(String[] args)  {
		final int MAX_DATASETS= 20;
		System.out.println("Arrays \tSteps \tData \t Ratio");
		for (int dataSets= 1; dataSets <= MAX_DATASETS; dataSets++) {
			Node[] tree= new Node[dataSets];
			for (int i= 0; i < tree.length; i++)
				tree[i]= new Node(generateData());

			// create the list of elements to be merged.
			MinHeap h = new MinHeap(tree);

			int weight= 0;
			for (int i =0; i< tree.length-1; i++) {		// -1 since we remove 2 TreeNodes from Heap each time
				Node lchild= (Node) h.delete();
				Node rchild= (Node) h.delete();
				Node pt = new Node(Merge.merge(lchild.data, rchild.data));
				weight += pt.data.length;
				h.insert(pt);
			}
			Node merged = (Node)h.delete();
			System.out.println(dataSets+" \t"+ weight+
					" \t"+ merged.data.length+" \t"+ ((float)weight)/merged.data.length);
		}		
	}
}